config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  resources :events, only: %w[index show create new edit update]
  # For details on the DSL available within this file, see https://guides.rubyonrails.org/routing.html

  root to: 'events#index'
end

app/models/application_record.rb
# frozen_string_literal: true

class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/event.rb
# frozen_string_literal: true

class Event < ApplicationRecord
  belongs_to :sport
  has_many :markets, dependent: :destroy

  accepts_nested_attributes_for :markets, allow_destroy: true, reject_if: ->(attrs) { attrs['kind'].blank? }

  validates :name, presence: true, uniqueness: true
end

app/models/market.rb
# frozen_string_literal: true

class Market < ApplicationRecord
  belongs_to :event
  has_many :outcomes, dependent: :destroy

  accepts_nested_attributes_for :outcomes, allow_destroy: true,
                                           reject_if: ->(attrs) { attrs['result'].blank? || attrs['price'].blank? }

  def outcomes_hash
    outcomes.to_h do |outcome|
      [outcome.result, outcome.price]
    end
  end
end

app/models/outcome.rb
# frozen_string_literal: true

class Outcome < ApplicationRecord
  belongs_to :market
end

app/models/sport.rb
# frozen_string_literal: true

class Sport < ApplicationRecord
  has_many :events, dependent: :destroy
end

app/controllers/application_controller.rb
# frozen_string_literal: true

class ApplicationController < ActionController::Base
end

app/controllers/events_controller.rb
# frozen_string_literal: true

class EventsController < ApplicationController
  def index
    @events = Event.order(created_at: :desc).page(params[:page])
  end

  def new
    @event = Event.new
    @event.markets.build.outcomes.build
    @sports = FetchSports.call(BetvictorApi)
  end

  def create
    sport.events.create!(event_params)
    redirect_to events_path
  rescue ActiveRecord::RecordInvalid => e
    @event = e.record
    @event.markets.build.outcomes.build
    @sports = FetchSports.call(BetvictorApi)
    render :new
  end

  def update
    @event = event
    @event.update!(event_params.merge(sport: sport))
    redirect_to event_path(@event)
  rescue ActiveRecord::RecordInvalid => e
    @event = e.record
    @sports = FetchSports.call(BetvictorApi)
    render :edit
  end

  def show
    @event = event
  end

  def edit
    @event = event
    @sports = FetchSports.call(BetvictorApi)
  end

  private

  def event_params
    params.require(:event).permit(:name, markets_attributes: [:id, :kind, :_destroy,
                                                              { outcomes_attributes: %i[id result price _destroy] }])
  end

  def sport
    sport_id = params[:event][:external_sport_id].to_i
    sport_name = FetchSports.call(BetvictorApi)[sport_id]
    Sport.find_or_create_by(external_sport_id: sport_id, name: sport_name)
  end

  def event
    Event.find(params[:id])
  end
end

app/helpers/application_helper.rb
# frozen_string_literal: true

module ApplicationHelper
end

app/helpers/form_helper.rb
# frozen_string_literal: true

module FormHelper
  def error_for(form, field)
    return nil if form.object.errors[field].empty?

    "<p class='error'>#{form.object.errors[field].first}</p>"
  end

  def link_to_add_fields(name, form, association, secondary_association = nil)
    new_object = form.object.send(association).build
    new_object.send(secondary_association).build if secondary_association
    id = new_object.object_id
    fields = form.fields_for(association, new_object, child_index: id) do |builder|
      render("#{association.to_s.singularize}_fields", form: builder)
    end

    link_to(name, '#', class: 'add-fields unlinked btn btn-outline-primary', data: { id: id, fields: fields.gsub("\n", '') })
  end
end

app/views/events/_form.slim
= form_with model: @event, local: true do |form|
  .row.g-2.align-items-center
    .col-auto
      = form.label :name, 'Name:', class: 'col-form-label'
    .col-auto
      = form.text_field :name, class: 'form-control'
      == error_for form, :name

  .row.g-2.align-items-center
    .col-auto
      = form.label :name, 'Sport:', class: 'col-form-label'
    .col-auto
      = form.select :external_sport_id, @sports.invert, class: 'form-select'
  br
  br
  h4
   | Markets

  = form.fields_for :markets do |markets_form|
    = render 'market_fields', form: markets_form
  = link_to_add_fields 'Add next markets', form, :markets, :outcomes

  br
  = form.submit 'Save', class: 'btn btn-primary'

app/views/events/_market_fields.slim
.nested-fields.container.border
  br
  = form.hidden_field :_destroy
  .row.g-3.align-items-center
    .col-auto
      = form.label :kind, 'Type:', class: 'col-form-label'
    .col-auto
      = form.text_field :kind, class: 'form-control'
      == error_for form, :kind
    .col-auto
      = link_to 'X', '#', class: 'remove-fields'

  br
  h6
   | Outcomes

  span
    = form.fields_for :outcomes do |outcomes_form|
      = render 'outcome_fields', form: outcomes_form
  span
    = link_to_add_fields 'Add next outcome', form, :outcomes

  br
  br

app/views/events/_outcome_fields.slim
.container
  span.nested-fields
    .row.g-4.align-items-center
      .col-auto
        = form.label :result, 'Result:', class: 'col-form-label'
      .col-auto
        = form.text_field :result, class: 'form-control'
      .col-auto
        = form.label :price, 'Price:', class: 'col-form-label'
      .col-auto
        = form.text_field :price, class: 'form-control'

app/views/events/edit.slim
h3
 | Edit event

br
br

= render 'form'

app/views/events/index.slim
= link_to 'Add event', new_event_path(), class: 'btn btn-primary'

br
br

- if @events.any?
  table.table
    thead
    tbody
      - @events.each do |event|
        tr.event
          td
            = link_to event.name, event_path(event)
  = paginate @events
- else
  | There's no events

app/views/events/new.slim
h3
 | New event

br
br

= render 'form'

app/views/events/show.slim
h3
  = @event.name
  span.badge.bg-primary
    = @event.sport.name

br
= link_to 'Edit', edit_event_path(), class: 'btn btn-primary'
br
br
table.table
  tbody
    - @event.markets.each do |market|
      tr
        td= market.kind

        - market.outcomes.each do |outcome|
          td
            .outcome-result= outcome.result
            .outcome-price= outcome.price

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html lang="en">
  <head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- Bootstrap CSS -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-eOJMYsd53ii+scO/bJGFsiCZc+5NDVN2yr8+0RDqr0Ql0h+rP48ckxlpbzKgwra6" crossorigin="anonymous">

    <title>InterviewApp</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>

    <div class='container'>
      <br>
      <br>
      <%= yield %>
    </div>

    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta3/dist/js/bootstrap.bundle.min.js" integrity="sha384-JEW9xMcG8R+pH31jmWH6WWP0WintQrMb4s7ZOdauHnUtxwoG2vI5DkLtS3qm9Ekf" crossorigin="anonymous"></script>
  </body>
</html>